<?php

function generate_files_by_metadata($metadata_folder = '/opt/plugins/metadata', $output_dir = __DIR__) {
	$titlecase = function($name) {
		$cased = '';
		foreach(explode('_', $name) as $part) {
			$cased .= mb_convert_case($part, MB_CASE_TITLE);
		}
		return $cased;
	};
	$metadata_files = glob($metadata_folder.'/*.metadata');
	if(!$metadata_files) {
		throw new Exception("No metadata files found.. I'm suspicous that you aren't doing your job right");
	}
	foreach($metadata_files as $filename) {
		$plugin_name = pathinfo($filename, PATHINFO_FILENAME);
		$cased_plugin = $titlecase($plugin_name);
		ob_start();
		require __DIR__.'/MetadataTest.php.in';
		file_put_contents($output_dir.'/'.$cased_plugin.'Test.php', "<?php\n".ob_get_clean());
	}
}

if(!debug_backtrace()) {
	// python's if __name__ == '__main__' :]
	try {
		generate_files_by_metadata();
	} catch(Exception $e) {
		fprintf(STDERR, $e->getMessage());
		exit(1);
	}
}
